//---------------------------------------------------------------------------

#ifndef mapunitH
#define mapunitH
//---------------------------------------------------------------------------

#include "util.h"
#include "tileunit.h"

#undef VAR
#undef INI

#ifdef mapunitCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

// aϹϮ
class TCell {
private:
  int FTileNo; // ϮҩmϤs
  int FLayer, FX, FY; // ϼh, y

  // Ϯ}H
  // SM_TILE_NUM_X x SM_TILE_NUM_Y ӤpϮ, "}"or"S}"
  typedef bool TBreakMap[SM_TILE_NUM_X][SM_TILE_NUM_Y];
  typedef TBreakMap* PBreakMap;

  PBreakMap FBreakPtr; // Ϯ}H
  TRect FRect; // ϮҦϰ, |HϮ}Hܧ

  Graphics::TBitmap* FCellBitmap, *FSMTileBitmap; // Ω}HϮ檺Kϰʧ@

  TTileAttr GetTileAttr();
  void SetTileAttr(const TTileAttr Value);

  bool GetCanPass(); // oӹϮ_qL ?
  void SetTileNo(int Value);

  // spϮҦϰ
  void CalcRect();
  // إ߹Ϯϧ (iO}H)
  void BuildCellBitmap();

  void BreakMapChanged();

  bool IsBroken(int x, int y);

  Graphics::TBitmap* GetTileBitmap(); // oϤ bitmap

  __property Graphics::TBitmap* TileBitmap = {read = GetTileBitmap};
protected:
public:
  TCell();
  ~TCell();

  void init(int Layer, int x, int y);

  // assignment constructor
  TCell& operator=(const TCell& c);

  // Jxs
  void LoadFromStream(TStream* Stream);
  void SaveToStream(TStream* Stream);

  // Ϯ}HBzk
  void AllocBreakMap(); // إ߹Ϯ}H
  void DisposeBreakMap(); // Ϯ}H
  void BreakBy(TRect ARect); // ̯xΰϰ]wϮ}H

  void Draw(TCanvas* Canvas);

  __property int TileNo = {read = FTileNo, write = SetTileNo};
  __property TTileAttr TileAttr = {read = GetTileAttr, write = SetTileAttr};

  __property TRect Rect = {read = FRect};

  __property bool CanPass = {read = GetCanPass};
};


class TMap {
private:
  static TMap* FInstance;
public:
  static TMap& Instance();
private:
  typedef TCell TMapArray[TILE_NUM_X][TILE_NUM_Y];

  TMapArray FMaps[LAYER_MAX + 1]; // (0 ~ LAYER_MAX) ha

  int FLevelNo; // ثeJds

  int FRole_X, FRole_Y; // ⪺_lm

  void SetLevelNo(int Value);

  void SetRole_X(int Value);
  void SetRole_Y(int Value);
protected:
  TMap();
  virtual ~TMap();

  AnsiString GetFileName(); // ھds, Ǧ^ɦW
public:
  void LoadFromFile();
  void SaveToFile();

  // NYaϼheb Canvas W
  void Draw(TCanvas* Canvas, int Layer);

  TCell& GetCell(int Layer, int x, int y);
  
  // ]ia, Υu]Y@h
  void ResetAllLayers();
  void ResetLayer(int Layer);

  __property int LevelNo = {read = FLevelNo, write = SetLevelNo};

  // olm
  __property int Role_X = {read = FRole_X, write = SetRole_X};
  __property int Role_Y = {read = FRole_Y, write = SetRole_Y};
};

#endif
